package io.github.serpro69.kfaker

/**
 * File names in `locales/en` directory.
 */
private val defaultFileNames = listOf(
    "address",
    "adjective",
    "ancient",
    "animal",
    "app",
    "appliance",
    "aqua_teen_hunger_force",
    "artist",
    "australia",
    "back_to_the_future",
    "bank",
    "barcode",
    "basketball",
    "beer",
    "bible",
    "big_bang_theory",
    "bird",
    "blood",
    "bojack_horseman",
    "book",
    "bossa_nova",
    "breaking_bad",
    "brooklyn_nine_nine",
    "buffy",
    "business",
    "camera",
    "cannabis",
    "cat",
    "chiquito",
    "chuck_norris",
    "clash_of_clan",
    "code",
    "coffee",
    "coin",
    "color",
    "commerce",
    "community",
    "company",
    "compass",
    "computer",
    "conan",
    "construction",
    "control",
    "cosmere",
    "crossfit",
    "crypto_coin",
    "culture_series",
    "currency",
    "dc_comics",
    "demographic",
    "departed",
    "dessert",
    "device",
    "dnd",
    "dog",
    "doraemon",
    "dota",
    "dr_who",
    "dragon_ball",
    "driving_license",
    "drone",
    "dumb_and_dumber",
    "dune",
    "educator",
    "elder_scrolls",
    "electrical_components",
    "emotion",
    "esport",
    "fallout",
    "family_guy",
    "file",
    "final_space",
    "finance",
    "fma_brotherhood",
    "food",
    "football",
    "fresh_prince_of_bel_air",
    "friends",
    "funny_name",
    "futurama",
    "game",
    "game_of_thrones",
    "gender",
    "ghostbusters",
    "grateful_dead",
    "greek_philosophers",
    "hacker",
    "half_life",
    "harry_potter",
    "heroes",
    "heroes_of_the_storm",
    "hey_arnold",
    "hipster",
    "hitchhikers_guide_to_the_galaxy",
    "hobbit",
    "hobby",
    "horse",
    "house",
    "how_i_met_your_mother",
    "how_to_train_your_dragon",
    "id_number",
    "industry_segments",
    "internet",
    "invoice",
    "jack_handey",
    "job",
    "kamen_rider",
    "kpop",
    "league_of_legends",
    "lebowski",
    "lord_of_the_rings",
    "lorem",
    "lovecraft",
    "markdown",
    "marketing",
    "measurement",
    "michael_scott",
    "military",
    "minecraft",
    "mountain",
    "movie",
    "music",
    "myst",
    "name",
    "naruto",
    "nation",
    "nato_phonetic_alphabet",
    "new_girl",
    "one_piece",
    "opera",
    "overwatch",
    "parks_and_rec",
    "pearl_jam",
    "phish",
    "phone_number",
    "pokemon",
    "prince",
    "princess_bride",
    "programming_language",
    "quote",
    "rajnikanth",
    "relationship",
    "restaurant",
    "rick_and_morty",
    "rock_band",
    "room",
    "rupaul",
    "rush",
    "science",
    "seinfeld",
    "shakespeare",
    "show",
    "silicon_valley",
    "simpsons",
    "slack_emoji",
    "sonic_the_hedgehog",
    "source",
    "south_park",
    "space",
    "star_trek",
    "star_wars",
    "stargate",
    "stranger_thing",
    "street_fighter",
    "stripe",
    "studio_ghibli",
    "subscription",
    "suits",
    "super_mario",
    "super_smash_bros",
    "superhero",
    "supernatural",
    "sword_art_online",
    "tea",
    "team",
    "the_expanse",
    "the_it_crowd",
    "the_kingkiller_chronicle",
    "the_office",
    "the_thick_of_it",
    "tolkien",
    "touhou",
    "tron",
    "twin_peaks",
    "umphreys_mcgee",
    "university",
    "v_for_vendetta",
    "vehicle",
    "venture_bros",
    "verbs",
    "volleyball",
    "warhammer_fantasy",
    "witcher",
    "world_cup",
    "world_of_warcraft",
    "yoda",
    "zelda",
)

/**
 * File names in `locales/fr` directory.
 */
private val frFileNames = listOf(
    "address",
    "adjective",
    "animal",
    "appliance",
    "book",
    "color",
    "company",
    "compass",
    "demographic",
    "gender",
    "internet",
    "lorem",
    "measurement",
    "name",
    "phone_number",
    "pokemon",
)

/**
 * File names in `locales/ja` directory.
 */
private val jaFileNames = listOf(
    "address",
    "adjective",
    "ancient",
    "animal",
    "bank",
    "book",
    "cat",
    "coffee",
    "color",
    "commerce",
    "company",
    "dog",
    "emotion",
    "food",
    "gender",
    "lorem",
    "name",
    "naruto",
    "overwatch",
    "phone_number",
    "pokemon",
    "relationship",
    "restaurant",
    "space",
    "studio_ghibli",
    "subscription",
    "super_mario",
    "super_smash_bros",
    "university",
    "zelda",
)

internal val fileNames: (locale: String) -> List<String> = {
    when (it) {
        "en" -> defaultFileNames
        "fr" -> frFileNames
        "ja" -> jaFileNames
        else -> throw IllegalArgumentException("Multi-file localized dictionaries not supported for locale '$it'.")
    }
}
